package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.utils.JSONUtil;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.websocket.WebSocketServer;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.entity.ShopChatConversation;
import com.gxwebsoft.shop.entity.ShopChatMessage;
import com.gxwebsoft.shop.param.ShopChatMessageParam;
import com.gxwebsoft.shop.service.ShopChatConversationService;
import com.gxwebsoft.shop.service.ShopChatMessageService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;

/**
 * 聊天消息表控制器
 *
 * @author 科技小王子
 * @since 2025-01-11 10:45:12
 */
@Tag(name = "聊天消息表管理")
@RestController
@RequestMapping("/api/shop/shop-chat-message")
public class ShopChatMessageController extends BaseController {
    @Resource
    private ShopChatMessageService shopChatMessageService;
    @Resource
    private WebSocketServer webSocketServer;
    @Resource
    private ShopChatConversationService shopChatConversationService;

    @Operation(summary = "分页查询聊天消息表")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopChatMessage>> page(ShopChatMessageParam param) {
        // 使用关联查询
        return success(shopChatMessageService.pageRel(param));
    }

    @Operation(summary = "查询全部聊天消息表")
    @GetMapping()
    public ApiResult<List<ShopChatMessage>> list(ShopChatMessageParam param) {
        // 使用关联查询
        List<ShopChatMessage> messages = shopChatMessageService.listRel(param);
        Integer loginUserId = getLoginUserId();
        for (ShopChatMessage message : messages) {
            message.setIsMine(message.getFormUserId().equals(loginUserId));
        }
        return success(messages);
    }

    @Operation(summary = "根据id查询聊天消息表")
    @GetMapping("/{id}")
    public ApiResult<ShopChatMessage> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(shopChatMessageService.getByIdRel(id));
    }

    @Operation(summary = "添加聊天消息表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopChatMessage shopChatMessage) throws IOException {
        // 获取当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            shopChatMessage.setFormUserId(loginUser.getUserId());
        }
        if (shopChatMessageService.save(shopChatMessage)) {
            HashMap<String, String> answerData = new HashMap<>();
            answerData.put("fromUserId", getLoginUserId().toString());
            answerData.put("content", shopChatMessage.getContent());
            ShopChatConversation conversation = shopChatConversationService.getById(shopChatMessage.getConversationId());
            Integer toUserId = conversation.getUserId().equals(getLoginUserId()) ? conversation.getFriendId() : conversation.getUserId();
            webSocketServer.sendMessage(shopChatMessage.getConversationId().toString() + "_" + toUserId, JSONUtil.toJSONString(answerData));
            webSocketServer.sendMessage(shopChatMessage.getConversationId().toString() + "_" + getLoginUserId(), JSONUtil.toJSONString(answerData));
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @Operation(summary = "修改聊天消息表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopChatMessage shopChatMessage) {
        if (shopChatMessageService.updateById(shopChatMessage)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @Operation(summary = "删除聊天消息表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopChatMessageService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @Operation(summary = "批量添加聊天消息表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopChatMessage> list) {
        if (shopChatMessageService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @Operation(summary = "批量修改聊天消息表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopChatMessage> batchParam) {
        if (batchParam.update(shopChatMessageService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @Operation(summary = "批量删除聊天消息表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopChatMessageService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
